BITS 32
%define CH1 -1     		;Hodnota chyby v prevodech 
GLOBAL arab_rim			;int arab_rim(int cis,char *s)
EXTERN mocnina			;int mocnina(int cislo,int exp)
EXTERN rim			;const char rim[]={'I','V','X','L','C','D','M'}
SECTION .data
  cislo dd 0
SECTION .text
arab_rim:
        push ebp
        mov ebp, esp
	pusha			;ulozi si puvodni stav regisru
        push ds
        pop es
        mov edi, [ebp+12]	;edi = *s
	mov edx, [ebp+8]	;edx = cis
	cmp edx,0		
	jnz vetsi_nule
	popa
	mov eax, CH1		;parametrem byla 0, tu nelze na rimske prevest
        mov esp, ebp
        pop ebp
	ret
vetsi_nule:
		;doplni retezec znaku 'M' pro reprezentaci tisicu
	mov al,'M'
tisice:				;for(;cis>=1000;cis-=1000)
	cmp edx,1000		;{
	jl mensi_tisic		;  s[j++]='M'
	sub edx,1000		;}
	stosb
	jmp tisice	
mensi_tisic:	

		;Prochazi 3 krat cyklem a doplni retezec reprezentujici 
		;stovky, desitky a jednotky

	mov [cislo],edx
	mov ebx,2		;misto i uziju ebx
cyklus:
	push ebx
	push dword 10
	call mocnina		;mocnina(10,i)
	pop ecx			;jen uklid zasobniku
	pop ebx			;jen uklid zasobniku
	mov esi,eax		;esi = mocnina(10,i)

		;Doplni znaky pro hodnoty 9*10^ebx (tedy 900, 90, 9) a tuto
		;hodnotu odecte
	mov word cx,9		
	imul cx			;eax = 9*mocnina(10,i)
	cmp [cislo], eax
	jl mensi9mocnin
	sub [cislo], eax
	mov al,[rim+ebx*2]	;doplni znak C; resp X, I v dalsich pruchodech
	stosb
	mov al,[rim+2+ebx*2]	;doplni znak M; resp C, X v dalsich pruchodech
	stosb
				;bylo doplneno CM, XC nebo IX  
mensi9mocnin:			

		;Doplni znaky pro hodnoty 5*10^ebx a tuto hodnotu odecte
	mov eax,esi		;eax = mocnina(10,i)
        mov word cx,5
        imul cx                 ;eax = 5*mocnina(10,i)
        cmp [cislo], eax
        jl mensi5mocnin
        sub [cislo], eax
        mov al,[rim+ebx*2+1]
        stosb
				;bylo doplneno D, L nebo V
mensi5mocnin:
		;Doplni znaky pro hodnoty eax*10^ebx a tuto hodnotu odecte
	xor edx,edx
        mov eax,[cislo]
	idiv esi
	mov esi,eax
m1:
	cmp eax,1		;[cislo] == 10^ebx
	jne m2
        mov al,[rim+ebx*2]	;al = 'C' ('X','I' v dalsich pruchodech)
        stosb
	mov [cislo],edx		;[cislo] -= 10^ebx neboli 
				;[cislo] %= mocnina(10,ebx)
	jmp mkonec		;bylo doplneno C, X nebo I
m2:
	cmp esi,2		;[cislo] == 2*10^ebx
        jne m3
        mov al,[rim+ebx*2]	;al = 'C' ('X','I' v dalsich pruchodech)
        stosb
	stosb
        mov [cislo],edx		;[cislo] -= 2*10^ebx
	jmp mkonec		;bylo doplneno CC, XX nebo II
m3:	
        cmp esi,3		;[cislo] == 3*10^ebx
        jne m4
        mov al,[rim+ebx*2]	;al = 'C' ('X','I' v dalsich pruchodech)
        stosb
        stosb
	stosb
        mov [cislo],edx		;[cislo] -= 3*10^ebx
        jmp mkonec		;bylo doplneno CCC, XXX nebo III
m4:
        cmp esi,4		;[cislo] == 4*10^ebx
        jne mkonec
        mov al,[rim+ebx*2]	;al = 'C' ('X','I' v dalsich pruchodech)
        stosb
	mov al,[rim+ebx*2+1]	;al = 'D' ('L','V' v dalsich pruchodech)
        stosb
        mov [cislo],edx		;[cislo] -= 4*10^ebx
				;bylo doplneno CD, XL nebo IV
mkonec
	dec ebx
	cmp ebx,0
	jge near cyklus		;dalsi iterace cyklu po snizeni citace ebx
	mov al,0		;ukonci retezec znakem '0'
	stosb
	popa			;uklidi po sobe registry
        mov eax, 0		;navratova hodnota 0 znamena, ze prevod probehl
        mov esp, ebp
        pop ebp
        ret

