BITS 32
%define MAX 512			;Maximalni delka retezce
%define RIM_ZNAKU 7		;Pocet rimskych znaku
%define CH1 -1     		;Hodnota chyby v prevodech 
%define CH2 -2     		;Hodnota chyby pro neregulerni rimske cislo 
GLOBAL rim_arab			;int rim_arab(char *rimske)
EXTERN strlen			;int strlen(char *)
EXTERN hodnota			;int hodnota(int pismeno) 
				;vraci index v pro hodnotu z pole hodnoty
EXTERN hodnoty			;const int hodnoty[]={1,5,10,50,100,500,1000}
SECTION .data
  delka dd 0
  cishod times MAX dd 0
  pocty times RIM_ZNAKU dd 0 
  navrat dd 0
SECTION .text
rim_arab:
        push ebp
        mov ebp, esp
	pusha			;pro jistotu
	xor eax,eax			
	mov ecx,RIM_ZNAKU
	cld
	mov edi,pocty
	rep stosd		;vymaz pole pocty
        mov esi, [ebp+8]	;esi = rimske (parametr funkce)
        push esi
	call strlen
	pop esi
	mov ecx,eax		;ecx = strlen(rimske)
	mov ebx,0		;ebx = i
;Prirazeni hodnot znaku rimskych cisel do pole cishod
c1: 
	cmp ebx,ecx		;while(i<delka)
	jge c1konec
	xor edx,edx
	mov byte dl,[esi+ebx]
	push edx
	call hodnota		;eax=hodnota(rimske[i])
	pop edi
	cmp eax, CH1		;if(hodnota(rimske[i]) == -1)
	jne bezchyb		
	popa			;uklidi po sobe registry 
	mov eax, CH1
	mov esp, ebp
        pop ebp
	ret			;vraci stejnou chybovou hodnotu jako hodnota()
bezchyb:
	mov edi,[hodnoty+eax*4]
	mov [cishod+ebx*4],edi    ;cishod[i]=hodnoty[hodnota(rimske[i])]
	inc dword [pocty+eax*4]	  ;pocty[hodnota(rimske[i])]++
	inc ebx			  ;i++
	jmp c1
c1konec:
	cmp dword [pocty+4],1		;znaku 'V' nesmi byt vice nez 1	
	jg near chyba
	cmp dword [pocty+3*4],1         ;znaku 'L' nesmi byt vice nez 1
	jg chyba
        cmp dword [pocty+5*4],1         ;znaku 'D' nesmi byt vice nez 1
        jg chyba
        cmp dword [pocty],3	        ;znaku 'I' nesmi byt vice nez 3
        jg chyba
        cmp dword [pocty+2*4],4         ;znaku 'X' nesmi byt vice nez 4
        jg chyba
        cmp dword [pocty+4*4],4         ;znaku 'C' nesmi byt vice nez 4
        jg chyba
	jmp bezchyb2
chyba:	
	popa				;uklidi po sobe registry
	mov eax, CH2
	mov esp, ebp
        pop ebp
        ret       			;vraci chybovou hodnotu -2
bezchyb2:

;Kontroluje kazdou hodnotu znaku rim. cisel se vsemi znaky s vyssim indexem
;Pokud je hodnota znaku mensi nez hodnota znaku s o 2 vetsim indexem,
;vraci chybovou hodnotu -2
;Odstrani chyby typu IVX,IIX,VIM apod.
	mov ebx,0			;i=0
	mov dword [delka],ecx		
	mov edx,ecx
	sub edx,1			;edx = delka-1
c2:					;for(i=0;i<delka-1;i++)
	cmp ebx,edx
	jge c2konec	
	mov ecx, ebx			;j=i
	inc ecx				;j=i+1
c3:					;for(j=i;j<delka-1;j++)
	cmp ecx,edx
	jge c3konec	
	mov edi,[cishod+ebx*4]
	cmp edi,[cishod+ecx*4+4]	;if(cishod[i]<cishod[j+i])
	jge bezchyb3
	popa				;uklidi po sobe registry
	mov eax, CH2			;return -2
	mov esp, ebp
        pop ebp
        ret
bezchyb3:				;konec if(cishod[i]<cishod[j+1])
	inc ecx
	jmp c3
c3konec: 				;konec for(j=i;j<delka-1;j++)
	inc ebx
	jmp c2
c2konec:				;konec for(i=0;i<delka-1;i++)

;Pokud jsou za sebou 4 stejne znaky a nejsou to M (1000) vraci chybovou 
;hodnotu -2
        mov ebx,0                       ;i=0
        mov dword edx,[delka]
        sub edx,3                       ;edx = delka-3	
c4:					;for(i=0;i<delka-3;i++)
	cmp ebx,edx
	jge c4konec

        mov edi,[cishod+ebx*4]
        cmp edi,[cishod+ebx*4+4]        ;if(cishod[i]==cishod[i+1] &&
        jne bezchyb4
        mov edi,[cishod+ebx*4+4]
        cmp edi,[cishod+ebx*4+8]        ;cishod[i+1]==cishod[i+2] &&
        jne bezchyb4
        mov edi,[cishod+ebx*4+8]
        cmp edi,[cishod+ebx*4+12]       ;cishod[i+2]==cishod[i+3] &&
        jne bezchyb4
        cmp dword [cishod+ebx*4],1000	;cishod[i] != 1000)
        je bezchyb4
	popa				;uklidi po sobe registry
        mov eax, CH2                    ;return -2
        mov esp, ebp
        pop ebp
        ret
bezchyb4:				;konec if( .... )
	inc ebx
	jmp c4
c4konec:				;konec for(i=0;i<delka-3;i++)

;Kontroluje retezce 'VX' 'LC' a 'DM', pri jejich vyskytu vraci -2
        mov ebx,0                       ;i=0
        mov dword edx,[delka]
        sub edx,1                       ;edx = delka-1
c5:					;for(i=0;i<delka-1;i++)
        cmp ebx,edx
        jge c5konec
        cmp dword [cishod+ebx*4],5	;if((cishod[i]==5 &&
	jne varianta2
        cmp dword [cishod+ebx*4+4],10	;cishod[i+1]==10) ||
	je splneno	        
varianta2:	
        cmp dword [cishod+ebx*4],50	;(cishod[i]==50 &&
        jne varianta3
        cmp dword [cishod+ebx*4+4],100	;cishod[i+1]==100) ||
        je splneno
varianta3:
        cmp dword [cishod+ebx*4],500	;(cishod[i]==500 &&
        jne nesplneno
        cmp dword [cishod+ebx*4+4],1000	;cishod[i+1]==1000))
        jne nesplneno
splneno:				;platna podminka, tedy chyba
	popa				;uklidi po sobe registry
        mov eax, CH2                    ;return -2
        mov esp, ebp
        pop ebp
        ret
nesplneno:				;neplatna podminka, dalsi iterace
	inc ebx
	jmp c5
c5konec:				;konec for(i=0;i<delka-1;i++)

;Cyklus prochazi hodnoty znaku retezce, pokud ma znak mensi hodnotu nez
;nasledujici, bude se odecitat 
        mov ebx,0                       ;i=0
        mov dword edx,[delka]
        sub edx,1                       ;edx = delka-1
c6:					;for(i=0;i<delka-1;i++)
        cmp ebx,edx
        jge c6konec
        mov edi,[cishod+ebx*4]
        cmp edi,[cishod+ebx*4+4]        ;if(cishod[i]==cishod[i+1])
        jge neodecist
	neg dword [cishod+ebx*4]	;cishod[i]= -cishod[i]
neodecist:
	inc ebx
	jmp c6
c6konec:

;Pokud je soucet hodnot 3 po sobe jdoucich znaku roven prostrednimu a prvni 
;nema hodnotu vetsi nez prostredni, vraci funkce -2
;Vylouci retezce typu IMI,VLV apod. ale ne MIM, CXC
        mov ebx,0                       ;i=0
        mov dword edx,[delka]
        sub edx,2                       ;edx = delka-2
c7:                                     ;for(i=0;i<delka-2;i++)
        cmp ebx,edx
        jge c7konec
	mov edi,[cishod+ebx*4]		;if(cishod[i]<cishod[i+1] &&
	cmp edi,[cishod+ebx*4+4]
	jge bezchyb5
	add edi,[cishod+ebx*4+4]	;cishod[i]+cishod[i+1]+cishod[i+2]==
	add edi,[cishod+ebx*4+8]	;==cishod[i+1]
	cmp edi,[cishod+ebx*4+4]	
	jne bezchyb5
	popa				;uklidi po sobe registry
        mov eax, CH2                    ;return -2
        mov esp, ebp
        pop ebp
        ret
bezchyb5:
        inc ebx
        jmp c7
c7konec:				;konec for(i=0;i<delka-2;i++)

;Secte hodnoty vsech znaku
        mov ebx,0                       ;i=0
        mov dword edx,[delka]
	xor eax,eax
c8:					;for(i=0;i<delka;i++)
        cmp ebx,edx
        jge c8konec
	add eax,[cishod+ebx*4]		;eax += cishod[i]
	inc ebx
	jmp c8
c8konec:				;konec for(i=0;i<delka;i++)
	mov [pocty],eax			;schovam si navratovou hodnotu
	popa 				;uklidim registry
	mov eax,[pocty]			;do eax vratim navratovou hodnotu
	mov esp, ebp
        pop ebp
        ret
